Subject: Re: [Anima] I-D Action: draft-behringer-anima-autonomic-addressing-01.txt

From: Brian E Carpenter <[email-masked]>
Date: Mon, 22 Jun 2015 14:08:32 +1200

Hi Michael,

Sitting waiting for a flight...

> IPv6 only: Autonomic processes should use exclusively IPv6, for	
> simplicity reasons.

I agree with this as long as it's an RFC 2119 SHOULD, i.e. IPv4
could be used in extraordinary circumstances. The GDNP design is
fundamentally IP-version independent.

> Separation: Autonomic address space is used separately from user	
> address space and other address realms.  This supports the robustness	
> requirement.

That applies to all AN traffic *using routable addresses*. However,
some autonomic signaling will require to be sent directly using link
local addresses, especially link local multicast addresses, during
discovery and bootstrap actions.

> Loopback-only: Only loopback interfaces ...

I know I'm repeating myself, but it really would be clearer if you
said this the other way round, and I don't think it affects what
you mean at all:

Overlay network: Routeable addresses for AN nodes are used exclusively in a
secure overlay network which is the basis of the ACP. This means that these
addresses will be assigned to the loopback interface in most operating
systems. All other interfaces exclusively use IPv6 link	local for autonomic
functions.  The usage of IPv6 link local addressing is discussed in [RFC7404].	
		 		
Use-ULA: For these overlay addresses of autonomic nodes, we use Unique	
Local Addresses (ULA), as specified in [RFC4193].  An alternative	
scheme was discussed, using assigned ULA addressing.  The consensus	
was to use standard ULA, because it was deemed to be sufficient.

   Brian

---

From: "Michael Behringer (mbehring)" <[email-masked]>
Date: Mon, 22 Jun 2015 16:59:14 +0000

> -----Original Message-----
> From: Anima [mailto:[email-masked]] On Behalf Of Brian E
> Carpenter
> Sent: 22 June 2015 04:09
> To: Anima WG
> Subject: Re: [Anima] I-D Action: draft-behringer-anima-autonomic-
> addressing-01.txt
> 
> Hi Michael,
> 
> I agree with this as long as it's an RFC 2119 SHOULD, i.e. IPv4 could be used in
> extraordinary circumstances. The GDNP design is fundamentally IP-version
> independent.

Yes, as long as it's really "extraordinary" ;-)   That 2119 says "SHOULD" means like you need a really good reason to not do it. What would such a good reason be? Just saying, in our implementation we often get the requirement "we want IPv4", and when you dig, the reason is that they don't want to deploy IPv6, and that's the only reason. Slippery slope... 

How would you avoid mission creep?
 
> That applies to all AN traffic *using routable addresses*. However, some
> autonomic signaling will require to be sent directly using link local
> addresses, especially link local multicast addresses, during discovery and
> bootstrap actions.

In my thinking, link local is also separate from user address space. I could mention explicitly that this includes link local? 
 
> I know I'm repeating myself, but it really would be clearer if you said this
> the other way round, and I don't think it affects what you mean at all:
> 
> Overlay network: Routeable addresses for AN nodes are used exclusively in
> a secure overlay network which is the basis of the ACP. This means that
> these addresses will be assigned to the loopback interface in most
> operating

This works for me. 

> was to use standard ULA, because it was deemed to be sufficient.

That too. 

Thanks for input! 

Michael

>    Brian
> 
> _______________________________________________
> Anima mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/anima

---

From: Brian E Carpenter <[email-masked]>
Date: Tue, 23 Jun 2015 09:24:20 +1200

All agreed but one comment added:

> How would you avoid mission creep?

Firstly we should stand firm on the ACP being self-creating and by definition
based on IPv6. Secondly, I can still imagine a case where a corner of a network
is still stuck in IPv4-only land, but we wanted to reach out to it. I have
enough experience with IPv6-over-IPv4 tunnels to not want to insist on tunneling
in such a case.

    Brian

---

From: Michael Richardson <[email-masked]>
Date: Wed, 24 Jun 2015 13:11:47 -0400

> Yes, as long as it's really "extraordinary" ;-)   That 2119 says
    > "SHOULD" means like you need a really good reason to not do it. What
    > would such a good reason be? Just saying, in our implementation we
    > often get the requirement "we want IPv4", and when you dig, the reason
    > is that they don't want to deploy IPv6, and that's the only
    > reason. Slippery slope...

a) to respond to the immediate "we want IPv4" --- I'd just tell the customer
   that it uses a custom link layer protocol that uses an ethernet type
   different than 0x0800... just like CDP does :-)
   (I don't think you need to "deploy" IPv6 to have an ACP...)

b) the only thing I care about is that nobody is allowed to say, "but
   mechanism XYZ does not exist in IPv4".  That's all.  I don't know if
   we will need IPv6-only things, but maybe.

...

    >> was to use standard ULA, because it was deemed to be sufficient.

It might be that ULA is an IPv6-only feature.
I don't consider 10/8 to be the same, as it is not statistically unique
inside the AS.

--
Michael Richardson <[email-masked]>, Sandelman Software Works
 -= IPv6 IoT consulting =-

---

From: Duzongpeng <[email-masked]>
Date: Thu, 25 Jun 2015 02:06:19 +0000

Hi, Michael Richardson:

	I agree with your option. Perhaps ACP is not needed to be IPv6 only.

	Of course, an IPv6 only autonomic control plane is ok for all the services in autonomic network, and the solution has the advantage of simplicity as mentioned by Michael Behringer.

	However, the network operator may be more familiar with the IPv4-base management.
	In the beginning of the ACP deployment, the network operator may not be very confident about the decisions made by the autonomic network. Some kinds of monitoring jobs may be desired by the network operators. At this time, the operator may want to see some IPv4 addresses. So, perhaps we need to provide IPv4-based ACP as an option for these parts of operators. Otherwise, we can only answer them "sorry, we only support IPv6 here".

	As IPv4 has been widely deployed, perhaps an IPv4-based autonomic network will be accepted by more network managers at the beginning.

	Indeed, at this time, an IPv4-based ACP is not as mature as the IPv6 one. Thus, perhaps some work needs to be done at this direction. For example, as you mentioned, how can we get an address instead of the ULA in IPv6.

Best regards
Zongpeng Du

-----Original Message-----
From: Anima [mailto:[email-masked]] On Behalf Of Michael Richardson
Sent: Thursday, June 25, 2015 1:12 AM
To: Michael Behringer (mbehring)
Cc: Anima WG
Subject: Re: [Anima] I-D Action: draft-behringer-anima-autonomic-addressing-01.txt

...

It might be that ULA is an IPv6-only feature.
I don't consider 10/8 to be the same, as it is not statistically unique inside the AS.

--
Michael Richardson <[email-masked]>, Sandelman Software Works  -= IPv6 IoT consulting =-

---

From: Sheng Jiang <[email-masked]>
Date: Thu, 25 Jun 2015 03:00:33 +0000

We never have a restriction said that Autonomic Network must be IPv6-based. The same for the ANIMA current charter. If there are customers want IPv4-based ACP or IPv4-based Autonomic Network, I guess we should also work on that. By saying so, I still prefer IPv6 over IPv4 because we are future network oriented, and I assume future network is more IPv6. If we could work out something IP Independent, it may be better.

Best regards,

Sheng

>From: Anima [mailto:[email-masked]] On Behalf Of Duzongpeng
>Sent: Thursday, June 25, 2015 10:06 AM
>To: Michael Richardson; Michael Behringer (mbehring)
>Cc: Anima WG
>Subject: [Anima] Whether IPv6 only for ACP? //RE: I-D Action:
>draft-behringer-anima-autonomic-addressing-01.txt
>
>Hi, Michael Richardson:
>
>	Of course, an IPv6 only autonomic control plane is ok for all the services
>in autonomic network, and the solution has the advantage of simplicity as
>mentioned by Michael Behringer.
>
>	In the beginning of the ACP deployment, the network operator may not
>be very confident about the decisions made by the autonomic network. Some
>kinds of monitoring jobs may be desired by the network operators. At this
>time, the operator may want to see some IPv4 addresses. So, perhaps we
>need to provide IPv4-based ACP as an option for these parts of operators.
>Otherwise, we can only answer them "sorry, we only support IPv6 here".
>
>	As IPv4 has been widely deployed, perhaps an IPv4-based autonomic
>network will be accepted by more network managers at the beginning.
>
>	Indeed, at this time, an IPv4-based ACP is not as mature as the IPv6 one.
>Thus, perhaps some work needs to be done at this direction. For example, as
>you mentioned, how can we get an address instead of the ULA in IPv6.
>
>Best regards
>Zongpeng Du
>
>Subject: Re: [Anima] I-D Action:
>draft-behringer-anima-autonomic-addressing-01.txt
>
>

---

From: "Michael Behringer (mbehring)" <[email-masked]>
Date: Thu, 25 Jun 2015 07:24:58 +0000

OK, I think there is some confusion around this topic. 

A network with autonomic functions (we all agree that a fully autonomic network is not our main target for now) can support on the *data plane* any protocol the operator wants to use, including IPv4, appletalk and IPv8 (when it comes). 

The statement is for the signalling, messaging and other protocols INSIDE the ACP, used by Autonomic Service Agents. 

Autonomic Service Agents will be exposed to a developer community, and the vendors implementing the ACP. There is absolutely no reason to standardise more than one protocol for this purpose. 

MichaelR is right: You don't need to actively deploy IPv6 to use the ACP. It just happens. With one caveat: If you connect an NMS system into the ACP for "virtual out of band" usage, then that system needs to support IPv6. But that is typically not a problem, in our experience. 

In other words: We're saying that *autonomic functions* (which the end user isn't exposed to at all) are exclusively IPv6, but the network can provide any service the operator wants. Specifically, an autonomic function (running on an IPv6 control plane) may well negotiate addressing for IPv4 services. 

Michael

> From: Duzongpeng [mailto:[email-masked]]
> Sent: 25 June 2015 04:06
> Subject: Whether IPv6 only for ACP? //RE: [Anima] I-D Action: draft-
> behringer-anima-autonomic-addressing-01.txt
> 
> Hi, Michael Richardson:
> 
> 	Of course, an IPv6 only autonomic control plane is ok for all the
> services in autonomic network, and the solution has the advantage of
> simplicity as mentioned by Michael Behringer.
> 
> 	In the beginning of the ACP deployment, the network operator may
> not be very confident about the decisions made by the autonomic network.
> Some kinds of monitoring jobs may be desired by the network operators. At
> this time, the operator may want to see some IPv4 addresses. So, perhaps
> we need to provide IPv4-based ACP as an option for these parts of
> operators. Otherwise, we can only answer them "sorry, we only support
> IPv6 here".
> 
> 	As IPv4 has been widely deployed, perhaps an IPv4-based
> autonomic network will be accepted by more network managers at the
> beginning.
> 
> 	Indeed, at this time, an IPv4-based ACP is not as mature as the IPv6
> one. Thus, perhaps some work needs to be done at this direction. For
> example, as you mentioned, how can we get an address instead of the ULA
> in IPv6.
> 
> Best regards
> Zongpeng Du
>

---

From: "Michael Behringer (mbehring)" <[email-masked]>
Date: Thu, 25 Jun 2015 07:31:14 +0000

Re-reading my own message, one thing to add: Brian has already stated that GDNP is protocol independent, and it should be. Of course we want to develop everything IP version independent wherever possible. 

But there has to be some default autonomic addressing, routing, and for THAT we want to look at IPv6 only at this point. 

Michael

> From: Anima [mailto:[email-masked]] On Behalf Of Michael
> Behringer (mbehring)
> Sent: 25 June 2015 09:25
> To: Duzongpeng; Michael Richardson
> Cc: Anima WG
> Subject: Re: [Anima] Whether IPv6 only for ACP? //RE: I-D Action: draft-
> A network with autonomic functions (we all agree that a fully autonomic
> network is not our main target for now) can support on the *data plane* any
> protocol the operator wants to use, including IPv4, appletalk and IPv8 (when
> it comes).
> 
> The statement is for the signalling, messaging and other protocols INSIDE
> the ACP, used by Autonomic Service Agents.
> 
> Autonomic Service Agents will be exposed to a developer community, and
> the vendors implementing the ACP. There is absolutely no reason to
> standardise more than one protocol for this purpose.
> 
> MichaelR is right: You don't need to actively deploy IPv6 to use the ACP. It
> just happens. With one caveat: If you connect an NMS system into the ACP
> for "virtual out of band" usage, then that system needs to support IPv6. But
> that is typically not a problem, in our experience.
> 
> In other words: We're saying that *autonomic functions* (which the end
> user isn't exposed to at all) are exclusively IPv6, but the network can
> provide any service the operator wants. Specifically, an autonomic function
> (running on an IPv6 control plane) may well negotiate addressing for IPv4
> services.
> 
> Michael
> 
> not
> > be very confident about the decisions made by the autonomic network.
> > Some kinds of monitoring jobs may be desired by the network operators.
> > At this time, the operator may want to see some IPv4 addresses. So,
> > perhaps we need to provide IPv4-based ACP as an option for these parts
> > of operators. Otherwise, we can only answer them "sorry, we only
> > support
> > IPv6 here".
> >
> autonomic
> > example, as you mentioned, how can we get an address instead of the
> > ULA in IPv6.
> >
> > Best regards
> > Zongpeng Du
> >
> > could be used in
> >     >> extraordinary circumstances. The GDNP design is fundamentally
> > IP- version
> >     >> independent.
> >

---

From: Duzongpeng <[email-masked]>
Date: Thu, 25 Jun 2015 08:10:02 +0000

Hi, Michael Behringer

Thanks for your reply. Please see inline.

Best regards
Zongpeng Du

-----Original Message-----
From: Michael Behringer (mbehring) [mailto:[email-masked]] 
Sent: Thursday, June 25, 2015 3:25 PM
To: Duzongpeng; Michael Richardson
Cc: Anima WG
Subject: RE: Whether IPv6 only for ACP? //RE: [Anima] I-D Action: draft-behringer-anima-autonomic-addressing-01.txt

[duzongpeng] Agree. [duzongpeng]

[duzongpeng] 
  I agree that it is vendor's job to implement ACP, and the ACP is kind of transparent for the operators. 

  Also, I agree that IPv6-based ACP works well for this purpose. 
  However, it does not mean that vendors can not implement an IPv4-based ACP.  

  Indeed, autonomic network's goal is to make management jobs as less as possible, but in some circumstance, the network operator do need to confirm every action of the network nodes. For examples, when debugging, or a high security level is suddenly needed. In this time, the ACP should not be transparent for the operators.

  We can not preclude this IPv4 requirement at the beginning. It should be the operator's option to use an IPv6-based or an IPv4-based one.
[duzongpeng]

[duzongpeng] 
  I agree that "it just happens". 

  However, if we have deployed an IPv4-based ACP, perhaps the solution for connecting an NMS system into the ACP for "virtual out of band" usage will become easier. Within an IPv4 network, perhaps the IPv4-based ACP has better compatibility than the IPv6 one.

  In my understanding, using IPv6 only ACP as you suggested will make the design jobs of autonomic control plane much easier. But, it is a tradeoff between doing less jobs and considering more about satisfying the different requirements of network managers. 

  Perhaps in future, when every network is IPv6, an IPv4-based ACP can be easily updated to IPv6-based because it can bootstrap itself, and all are autonomic.
[duzongpeng]

Michael

> Richardson

---

From: Duzongpeng <[email-masked]>
Date: Thu, 25 Jun 2015 08:23:51 +0000

Hi, Michael Behringer

I agree that the default setting of the ACP could be IPv6-based, which may make the communication across autonomic domains easier to implement.

What I suggested is that we first have an IPv6-based ACP ready, and define an IPv4-based one as an alternative option.

Best regards
Zongpeng Du

-----Original Message-----
From: Anima [mailto:[email-masked]] On Behalf Of Michael Behringer (mbehring)
Sent: Thursday, June 25, 2015 3:31 PM
To: Duzongpeng; Michael Richardson
Cc: Anima WG
Subject: Re: [Anima] Whether IPv6 only for ACP? //RE: I-D Action: draft-behringer-anima-autonomic-addressing-01.txt

Michael

> Subject: Re: [Anima] Whether IPv6 only for ACP? //RE: I-D Action: 
> draft- behringer-anima-autonomic-addressing-01.txt
> 
> A network with autonomic functions (we all agree that a fully 
> autonomic network is not our main target for now) can support on the 
> *data plane* any protocol the operator wants to use, including IPv4, 
> appletalk and IPv8 (when it comes).
> 
> The statement is for the signalling, messaging and other protocols 
> INSIDE the ACP, used by Autonomic Service Agents.
> 
> MichaelR is right: You don't need to actively deploy IPv6 to use the 
> ACP. It just happens. With one caveat: If you connect an NMS system 
> into the ACP for "virtual out of band" usage, then that system needs 
> to support IPv6. But that is typically not a problem, in our experience.
> 
> user isn't exposed to at all) are exclusively IPv6, but the network 
> can provide any service the operator wants. Specifically, an autonomic 
> function (running on an IPv6 control plane) may well negotiate 
> addressing for IPv4 services.
> 
> Michael
> 
> > perhaps we need to provide IPv4-based ACP as an option for these 
> > parts of operators. Otherwise, we can only answer them "sorry, we 
> > only support
> > IPv6 here".
> >
> > 	Indeed, at this time, an IPv4-based ACP is not as mature as the 
> > IPv6 one. Thus, perhaps some work needs to be done at this 
> > direction. For example, as you mentioned, how can we get an address 
> > instead of the ULA in IPv6.
> >
> > Best regards
> > Zongpeng Du
> >

---

From: "Michael Behringer (mbehring)" <[email-masked]>
Date: Thu, 25 Jun 2015 11:56:19 +0000

For something new like AN, where the standardised specs will take at least a couple of years to appear in anyone's products, where we do NOT have backward compatibility issues, where we do not address end systems for some years to come, I personally think it is insane to even consider IPv4. 

But I think we do have agreement that we start with IPv6 only, and just keep the door open, in case we need to support it. If the working group wants to do that, I'll change the text accordingly. Maybe a discussion for Prague? 

Michael

> Sent: 25 June 2015 10:24
> To: Michael Behringer (mbehring); Michael Richardson
> Cc: Anima WG
> Subject: RE: [Anima] Whether IPv6 only for ACP? //RE: I-D Action: draft-
> I agree that the default setting of the ACP could be IPv6-based, which may
> make the communication across autonomic domains easier to implement.
> 
> What I suggested is that we first have an IPv6-based ACP ready, and define
> an IPv4-based one as an alternative option.
> 
> Best regards
> Zongpeng Du
> 
> Re-reading my own message, one thing to add: Brian has already stated that
> GDNP is protocol independent, and it should be. Of course we want to
> develop everything IP version independent wherever possible.
> 
> But there has to be some default autonomic addressing, routing, and for
> THAT we want to look at IPv6 only at this point.
> 
> Michael
>

---

From: Brian E Carpenter <[email-masked]>
Date: Fri, 26 Jun 2015 09:31:47 +1200

> 	I agree with your option. Perhaps ACP is not needed to be IPv6 only.

However, IPv6 has an enormous advantage in a cold start with all devices
assumed in factory condition. Every IPv6 stack will acquire a valid link-local
address even if no other device (such as a router or DHCP server) is configured
and there is no Intent in place. That is what we need for a true AN.

> 	However, the network operator may be more familiar with the IPv4-base management.

I'm sorry but such operators are quickly becoming dinosaurs. Looking at the
current growth rate of IPv6, and knowing that it will take several years
for Anima work to be complete, I think those operators will be in serious
trouble.

> 	In the beginning of the ACP deployment, the network operator may not be very confident about the decisions made by the autonomic network. Some kinds of monitoring jobs may be desired by the network operators. At this time, the operator may want to see some IPv4 addresses. 

Their traditional NMS could still be IPv4, and they could still see IPv4 information
through an IPv6 ACP.

> So, perhaps we need to provide IPv4-based ACP as an option for these parts of operators. Otherwise, we can only answer them "sorry, we only support IPv6 here".

No, the answer is "IPv6 will be deployed automatically with no work by you, but
old IPv4 services will not be interrupted."

Actually we should think about an "IPv4 management" use case for AN, running
over an IPv6 ACP.

Best regards,
   Brian

> .

---

From: Sheng Jiang <[email-masked]>
Date: Fri, 26 Jun 2015 01:32:07 +0000

Hi, Brian and Michael B,

In my reading, it seems we take a wrong argument here. What we are talking about is NOT stop IPv6-based ACP. It is remaining on our priority or default choice. Technically, I am not sure the possibility or feasibility IP independent. If yes, IP independent may be preferred over IPv6-only.

But meanwhile, a parallel IPv4-based ACP (or IP independent) mechanism should not bring any harm. IPv4 based Internet/networks are still having the motivation to improve itself. Particularly, many closed enterprise networks many remain IPv4-only for a while. Many IETF WG, such as DHC, are working on both IPv4 and IPv6 simultaneously, of course, with IPv4 in lower preference and priority.

"IPv4 management" use case for AN, running over an IPv6 ACP would also be an interest use case. It is valuable in the dual stack network or "running IPv4 as a service".

Regards,

Sheng

>Sent: Friday, June 26, 2015 5:32 AM
>To: [email-masked]
>time, the operator may want to see some IPv4 addresses.
>
>> So, perhaps we need to provide IPv4-based ACP as an option for these parts
>of operators. Otherwise, we can only answer them "sorry, we only support
>IPv6 here".
>
>IP-version

---

From: "Michael Behringer (mbehring)" <[email-masked]>
Date: Fri, 26 Jun 2015 07:14:20 +0000

Sheng: WHY??? Why would you want an IPv4 control plane? If you have a good answer to that question, we can argue. :-) 

Take BGP: It can run on either v4 or v6, and it can negotiate any protocol under the sun. the control plane protocol has little to do with what it negotiates. 

Take ISIS: It's not even IP!! 

Other WGs may have good reasons: For example: interfacing end systems where we cannot expect IPv6 support. AN is NEW, the ANI is NEW, there is no legacy. 

Michael

> From: Sheng Jiang [mailto:[email-masked]]
> Sent: 26 June 2015 03:32
> To: Brian E Carpenter; [email-masked]; Michael Behringer (mbehring);
> Michael Richardson
> Cc: Duzongpeng
> In my reading, it seems we take a wrong argument here. What we are
> talking about is NOT stop IPv6-based ACP. It is remaining on our priority or
> default choice. Technically, I am not sure the possibility or feasibility IP
> independent. If yes, IP independent may be preferred over IPv6-only.
> 
> But meanwhile, a parallel IPv4-based ACP (or IP independent) mechanism
> should not bring any harm. IPv4 based Internet/networks are still having the
> motivation to improve itself. Particularly, many closed enterprise networks
> many remain IPv4-only for a while. Many IETF WG, such as DHC, are working
> on both IPv4 and IPv6 simultaneously, of course, with IPv4 in lower
> preference and priority.
> 
> "IPv4 management" use case for AN, running over an IPv6 ACP would also
> be an interest use case. It is valuable in the dual stack network or "running
> IPv4 as a service".
> 
> Regards,
> 
> Sheng
> 
> >However, IPv6 has an enormous advantage in a cold start with all
> >devices assumed in factory condition. Every IPv6 stack will acquire a
> >valid link-local address even if no other device (such as a router or
> >DHCP server) is configured and there is no Intent in place. That is what we
> need for a true AN.
> >
> >>
> >> services
> >in autonomic network, and the solution has the advantage of simplicity
> >as mentioned by Michael Behringer.
> >>
> >> 	However, the network operator may be more familiar with the
> >> IPv4-base
> >management.
> >
> >I'm sorry but such operators are quickly becoming dinosaurs. Looking at
> >the current growth rate of IPv6, and knowing that it will take several
> >years for Anima work to be complete, I think those operators will be in
> >serious trouble.
> >
> >At this time, the operator may want to see some IPv4 addresses.
> >
> >Their traditional NMS could still be IPv4, and they could still see
> >IPv4 information through an IPv6 ACP.
> >
> >No, the answer is "IPv6 will be deployed automatically with no work by
> >you, but old IPv4 services will not be interrupted."
> >
> >Actually we should think about an "IPv4 management" use case for AN,
> >running over an IPv6 ACP.
> >
> >Best regards,
> >   Brian
> >
> >>
> one.
> >Thus, perhaps some work needs to be done at this direction. For
> >>     >> I agree with this as long as it's an RFC 2119 SHOULD, i.e.
> >> IPv4 could
> >be used in
> >>     >> Use-ULA: For these overlay addresses of autonomic nodes, we
> >> use
> >Unique
> >> I don't consider 10/8 to be the same, as it is not statistically
> >> unique inside
> >the AS.
> >>
> >> --

---

From: Sheng Jiang <[email-masked]>
Date: Fri, 26 Jun 2015 07:41:06 +0000

So, you are saying we should never have a IPv4-based Autonomic Network? It may be waste if all devices have been dual-stack or IPv6-only. But it would still be long way to come. I have been working on IPv6 since 2001. At that time, we were expecting IPv4 might be terminated by 2006. There are new features that are developed with IPv6, but later they are also adopted into IPv4. In last 20 years, the technologies in IPv4 did not stop. If ACP or other AN functions can be incrementally added into legacy IPv4 devices, it would not be any harm for owners. So, that AN is new does not mean it could not use in IPv4.

Don't get me wrong. I am NOT arguing that we "must" do that. Again, as I said, we "may" do that with low priority while I don't think it harms. If there are clearly requirements from operators, we may rise the "may" to be "should".

Regards,

Sheng

>Sent: Friday, June 26, 2015 3:14 PM
>To: Sheng Jiang; Brian E Carpenter; [email-masked]; Michael Richardson
>Cc: Duzongpeng
>Subject: RE: [Anima] Whether IPv6 only for ACP? //RE: I-D Action:
>Sheng: WHY??? Why would you want an IPv4 control plane? If you have a
>good answer to that question, we can argue. :-)
>
>Take BGP: It can run on either v4 or v6, and it can negotiate any protocol
>under the sun. the control plane protocol has little to do with what it
>negotiates.
>
>Other WGs may have good reasons: For example: interfacing end systems
>where we cannot expect IPv6 support. AN is NEW, the ANI is NEW, there is no
>legacy.
>
>Michael
>

---

From: "Jonathan Hansford" <[email-masked]>
Date: Fri, 26 Jun 2015 09:36:27 +0100

There are some systems outside the Internet that have no urgent need
to move to IPv6 and developers would rather focus on more urgent
needs.  Autonomic networking could well be one of those more urgent
needs.
Jonathan

----- Original Message -----
From: "Michael Behringer (mbehring)" 
To:"Duzongpeng" , "Michael Richardson" 
Cc:"Anima WG" 
Sent:Thu, 25 Jun 2015 11:56:19 +0000
Subject:Re: [Anima] Whether IPv6 only for ACP? //RE: I-D Action:
draft-behringer-anima-autonomic-addressing-01.txt

 For something new like AN, where the standardised specs will take at
least a couple of years to appear in anyone's products, where we do
NOT have backward compatibility issues, where we do not address end
systems for some years to come, I personally think it is insane to
even consider IPv4. 

 But I think we do have agreement that we start with IPv6 only, and
just keep the door open, in case we need to support it. If the working
group wants to do that, I'll change the text accordingly. Maybe a
discussion for Prague? 

 Michael

 > Subject: RE: [Anima] Whether IPv6 only for ACP? //RE: I-D Action:
draft-
 > Subject: Re: [Anima] Whether IPv6 only for ACP? //RE: I-D Action:
draft-
 > > > However, the network operator may be more familiar with the
IPv4-
 > > > base management.
So,
 > > > Subject: Re: [Anima] I-D Action:
draft-behringer-anima-autonomic-
 > > > addressing-01.txt
 > > >
 > > >
 > > > Michael Behringer (mbehring)  wrote:
 > > > IPv4 could be used in
 > > > > "SHOULD" means like you need a really good reason to not do
it.
 > What
 &gt

---

From: "Jonathan Hansford" <[email-masked]>
Date: Fri, 26 Jun 2015 09:38:57 +0100

----- Original Message -----

 Michael

draft-
draft-
IPv4-
So,
it.
 > > > a) to respond to the immediate "we want IPv4" --- I'd just tell
the
 > > customer
 > > > ..
 > > > use Unique
 > > > unique inside the AS.
 > > > Michael Richardson , Sandelman Software
 > > Works

---

From: Duzongpeng <[email-masked]>
Date: Fri, 26 Jun 2015 09:35:33 +0000

Hi Jonathan:

         I think you are talking about the network in the enterprise and campus, where might be IPv4.

         This part of customs don’t care much about what technology is used underneath the network. They only care about the service layer.

They want the detailed network information as transparent as possible. Autonomic network can surely fulfill these needs.

Best Regards
Zongpeng Du

From: Anima [mailto:[email-masked]] On Behalf Of Jonathan Hansford
Sent: Friday, June 26, 2015 4:39 PM
To: Michael Behringer (mbehring); Duzongpeng; Michael Richardson
Cc: Anima WG
Subject: Re: [Anima] Whether IPv6 only for ACP? //RE: I-D Action: draft-behringer-anima-autonomic-addressing-01.txt

There are some systems outside the Internet that have no urgent need to move to IPv6 and developers would rather focus on more urgent needs.  Autonomic networking could well be one of those more urgent needs.

Jonathan

----- Original Message -----
From:
"Michael Behringer (mbehring)" <[email-masked]<mailto:[email-masked]>>

To:
"Duzongpeng" <[email-masked]<mailto:[email-masked]>>, "Michael Richardson" <[email-masked]<mailto:[email-masked]>>
Cc:
"Anima WG" <[email-masked]<mailto:[email-masked]>>
Sent:
Thu, 25 Jun 2015 11:56:19 +0000
Subject:
Re: [Anima] Whether IPv6 only for ACP? //RE: I-D Action: draft-behringer-anima-autonomic-addressing-01.txt

Michael

> > > Michael Behringer (mbehring) <[email-masked]<mailto:[email-masked]>> wrote:
> > > Michael Richardson <[email-masked]<mailto:[email-masked]>>, Sandelman Software
> > Works
> > [email-masked]<mailto:[email-masked]>
> [email-masked]<mailto:[email-masked]>

_______________________________________________
Anima mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/anima

---

From: "Jonathan Hansford" <[email-masked]>
Date: Fri, 26 Jun 2015 11:43:01 +0100

I'm thinking particularly about closed networks such as used by the
military where budgets can be tight, capabilities have to be traded
and replacement of many devices could occur in the 10+ years
timescale. Consequently many (most?) devices could be stuck on IPv4
for a long period of time. In those types of environments, network
management can be very labour intensive and the provision of autonomic
networking could well be considered a far better investment than
switching to IPv6, replacing a lot of expensive hardware that can only
support IPv4

----- Original Message -----
From: "Duzongpeng" 
To:"Jonathan Hansford" , "Michael Behringer (mbehring)" , "Michael
Richardson" 
Cc:"Anima WG" 
Sent:Fri, 26 Jun 2015 09:35:33 +0000
Subject:RE: [Anima] Whether IPv6 only for ACP? //RE: I-D Action:
draft-behringer-anima-autonomic-addressing-01.txt

	Hi Jonathan:

	         I think you are talking about the network in the
enterprise and campus, where might be IPv4.

	         This part of customs don’t care much about what
technology is used underneath the network. They only care about the
service layer.

	They want the detailed network information as transparent as
possible. Autonomic network can surely fulfill these needs.

	Best Regards

	Zongpeng Du

	FROM: Anima [mailto:[email-masked]] ON BEHALF OF Jonathan
Hansford
SENT: Friday, June 26, 2015 4:39 PM
TO: Michael Behringer (mbehring); Duzongpeng; Michael Richardson
CC: Anima WG
SUBJECT: Re: [Anima] Whether IPv6 only for ACP? //RE: I-D Action:
draft-behringer-anima-autonomic-addressing-01.txt

	Jonathan

 ----- Original Message -----

	FROM:

	"Michael Behringer (mbehring)" 

	TO:

	"Duzongpeng" , "Michael Richardson" 

	CC:

	"Anima WG" 

	SENT:

	SUBJECT:

	Re: [Anima] Whether IPv6 only for ACP? //RE: I-D Action:
draft-behringer-anima-autonomic-addressing-01.txt

 Michael

 > From: Duzongpeng [mailto:[email-masked] [5]]
 > Sent: 25 June 2015 10:24
draft-
 > From: Anima [mailto:[email-masked] [6]] On Behalf Of
Michael
draft-
 > > From: Anima [mailto:[email-masked] [7]] On Behalf Of
Michael
 > > > From: Duzongpeng [mailto:[email-masked] [8]]
 > > > Sent: 25 June 2015 04:06
IPv4-
So,
 > > > From: Anima [mailto:[email-masked] [9]] On Behalf Of
Michael
it.
 > > > > reason Slippery slope...
the
 > > [email-masked] [12]
 > > https://www.ietf.org/mailman/listinfo/anima [13]
 > 
 > [email-masked] [14]
 > https://www.ietf.org/mailman/listinfo/anima [15]

 _______________________________________________
 Anima mailing list
[email-masked] [16]
https://www.ietf.org/mailman/listinfo/anima [17]

Links:
------
[1] mailto:[email-masked]
[2] mailto:[email-masked]
[3] mailto:[email-masked]
[4] mailto:[email-masked]
[5] mailto:[email-masked]
[6] mailto:[email-masked]
[7] mailto:[email-masked]
[8] mailto:[email-masked]
[9] mailto:[email-masked]
[10] mailto:[email-masked]
[11] mailto:[email-masked]
[12] mailto:[email-masked]
[13] https://www.ietf.org/mailman/listinfo/anima
[14] mailto:Anima@ietforg
[15] https://www.ietf.org/mailman/listinfo/anima
[16] mailto:[email-masked]
[17] https://www.ietf.org/mailman/listinfo/anima

---

From: Paul Duffy <[email-masked]>
Date: Fri, 26 Jun 2015 10:56:48 -0400

Surely this WG understands the difference in the IPv6 deployment 
situation 2001 versus 2015.

All major platform OSs ship today IPv6 enabled.  Many major service 
providers are already IPv6 enabled or in the process of switching over. 
IEC TC57 (Power Systems) requires that all new and evolution of current 
standards support IPv6 starting 2015. The embedded RTOS space is a 
laggard, but that is also changing fast. IPv6 is the only way to go in 
the constrained / LLN space ... look at the work ongoing in the IETF 
6lo, Wi-SUN Alliance, Thread Group, OIC, uPnP, etc.  I could go on 
further, but I'm bored ;)

Are we really going to argue AMINA IPv4 support based on the situation 
in 2001?

Its my strong desire that this WG not in any way let IPv4 considerations 
delay your ACP work.  Lead us into the future.

Cheers

---

From: Michael Richardson <[email-masked]>
Date: Fri, 26 Jun 2015 14:47:14 -0400

> needs. Autonomic networking could well be one of those more urgent

The Autonomic Control Plane is *not* IPv6. It just looks like IPv6.

It's a new fangled protocol that has nothing to do with any of the deployed
production network.  As such, it is *ENTIRELY* greenfield.
It's all new code.   It likely doesn't even get forwarded using whatever
ASICs your hardware might have...

If someone wants to do this with something that looks like IPv4, that's
fine, but I want nobody complaining if we specify a mechanism (such as ULAs
or ND or SEND) that does never been defined in the thing that looks like IPv4.

---

From: Brian E Carpenter <[email-masked]>
Date: Sat, 27 Jun 2015 08:45:33 +1200

> needs.  Autonomic networking could well be one of those more urgent

What is the harm if the AN products that they install happen to configure
themselves to use IPv6? Since any router that acts as an autonomic node
will be modern enough to support an IPv6 ACP with no manual intervention,
why would the operator even know or care?

    Brian

---

From: Duzongpeng <[email-masked]>
Date: Sat, 27 Jun 2015 01:55:37 +0000

Hi Paul:

	I want make some clarifications. What I have suggested is to do an IPv6-ACP first, and considering an IPv4 one if needed.
So, I don't think it results in any delay for the former one.
	I agree that it is the trend that IPv6 will replace IPv4 in future, but for better popularization of Autonomic network, maybe we can provide some alternative options to network operators.

Best Regards
Zongpeng Du

-----Original Message-----
From: Anima [mailto:[email-masked]] On Behalf Of Paul Duffy
Sent: Friday, June 26, 2015 10:57 PM
To: [email-masked]
Subject: Re: [Anima] Whether IPv6 only for ACP? //RE: I-D Action: draft-behringer-anima-autonomic-addressing-01.txt

Surely this WG understands the difference in the IPv6 deployment situation 2001 versus 2015.

All major platform OSs ship today IPv6 enabled.  Many major service providers are already IPv6 enabled or in the process of switching over. 
IEC TC57 (Power Systems) requires that all new and evolution of current standards support IPv6 starting 2015. The embedded RTOS space is a laggard, but that is also changing fast. IPv6 is the only way to go in the constrained / LLN space ... look at the work ongoing in the IETF 6lo, Wi-SUN Alliance, Thread Group, OIC, uPnP, etc.  I could go on further, but I'm bored ;)

Are we really going to argue AMINA IPv4 support based on the situation in 2001?

Its my strong desire that this WG not in any way let IPv4 considerations delay your ACP work.  Lead us into the future.

Cheers

On 6/26/2015 3:41 AM, Sheng Jiang wrote:
>> Take BGP: It can run on either v4 or v6, and it can negotiate any 
>> protocol under the sun. the control plane protocol has little to do 
>> with what it negotiates.
>>
>> where we cannot expect IPv6 support. AN is NEW, the ANI is NEW, there 
>> is no legacy.
>>
>> Michael
>>
>>> talking about is NOT stop IPv6-based ACP. It is remaining on our 
>>> priority or default choice. Technically, I am not sure the 
>>> possibility or feasibility IP independent. If yes, IP independent may be preferred over IPv6-only.
>>>
>>> But meanwhile, a parallel IPv4-based ACP (or IP independent) 
>>> mechanism should not bring any harm. IPv4 based Internet/networks 
>>> are still having the motivation to improve itself. Particularly, 
>>> many closed enterprise networks many remain IPv4-only for a while. 
>>> Many IETF WG, such as DHC, are
>> working
>>> "IPv4 management" use case for AN, running over an IPv6 ACP would 
>>> also be an interest use case. It is valuable in the dual stack 
>>> network or "running
>>> IPv4 as a service".
>>>
>>> Regards,
>>>
>>> Sheng
>>>
>>>> devices assumed in factory condition. Every IPv6 stack will acquire 
>>>> a valid link-local address even if no other device (such as a 
>>>> router or DHCP server) is configured and there is no Intent in 
>>>> place. That is what we
>>> need for a true AN.
>>>> in autonomic network, and the solution has the advantage of 
>>>> I'm sorry but such operators are quickly becoming dinosaurs. 
>>>> Looking at the current growth rate of IPv6, and knowing that it 
>>>> will take several years for Anima work to be complete, I think 
>>>> those operators will be in serious trouble.
>>>>
>>>> No, the answer is "IPv6 will be deployed automatically with no work 
>>>> by you, but old IPv4 services will not be interrupted."
>>>>
>>>> Actually we should think about an "IPv4 management" use case for 
>>>> AN, running over an IPv6 ACP.
>>>>
>>>> Best regards,
>>>>    Brian
>>>>
>>>>> IPv6
>>>> ULA
>>>>>      >> > IPv6 only: Autonomic processes should use exclusively 
>>>>> IPv6,
>> for
>>>>>      >> > simplicity reasons.
>>>>>      >>
>>>>>      > would such a good reason be? Just saying, in our 
>>>>> implementation
>> we
>>>>>      > often get the requirement "we want IPv4", and when you dig, 
>>>>> the
>>>> reason
>>>>>      >> Use-ULA: For these overlay addresses of autonomic nodes, 
>>>>> we use
>>>> Unique

---

From: Duzongpeng <[email-masked]>
Date: Sat, 27 Jun 2015 02:23:38 +0000

Hi Brian,

In my understanding, although the ACP is designed as transparent as possible, it does mean that the operator will never notice them in practice.

Sometimes, the ACP needs to be able to connect to a NMS which may be an IPv4 one. 

Sometimes, operators must be able to ensure the ACP is not misused, such as in debugging.

IMO, we can not assume that IPv6 would have replaced all the IPv4 when autonomic network becomes a common commercial feature.

Even if it is only a requirement from a small part of operators who care more about compatibility, it is worth considering.

Best Regards
Zongpeng Du

-----Original Message-----
From: Anima [mailto:[email-masked]] On Behalf Of Brian E Carpenter
Sent: Saturday, June 27, 2015 4:46 AM
To: [email-masked]
Subject: Re: [Anima] Whether IPv6 only for ACP? //RE: I-D Action: draft-behringer-anima-autonomic-addressing-01.txt

> needs.  Autonomic networking could well be one of those more urgent 

What is the harm if the AN products that they install happen to configure themselves to use IPv6? Since any router that acts as an autonomic node will be modern enough to support an IPv6 ACP with no manual intervention, why would the operator even know or care?

    Brian

>  > From: Duzongpeng [mailto:[email-masked]]  > Sent: 25 June 
> 2015 10:24  > To: Michael Behringer (mbehring); Michael Richardson  > 
> Cc: Anima WG  > Subject: RE: [Anima] Whether IPv6 only for ACP? //RE: 
> I-D Action:
> draft-
>  > I agree that the default setting of the ACP could be IPv6-based, 
> which may  > make the communication across autonomic domains easier to 
> implement.
>  >
>  > What I suggested is that we first have an IPv6-based ACP ready, and 
> define  > an IPv4-based one as an alternative option.
>  >
>  > Best regards
>  > Zongpeng Du
>  >
>  > From: Anima [mailto:[email-masked]] On Behalf Of Michael  > 
> Behringer (mbehring)  > Sent: Thursday, June 25, 2015 3:31 PM  > To: 
> Duzongpeng; Michael Richardson  > Cc: Anima WG  > Subject: Re: [Anima] 
> Whether IPv6 only for ACP? //RE: I-D Action:
> draft-
>  > Re-reading my own message, one thing to add: Brian has already 
> stated that  > GDNP is protocol independent, and it should be. Of 
> course we want to  > develop everything IP version independent 
> wherever possible.
>  >
>  > But there has to be some default autonomic addressing, routing, and 
> for  > THAT we want to look at IPv6 only at this point.
>  >
>  > Michael
>  >
> > > Behringer (mbehring)  > > Sent: 25 June 2015 09:25  > > To: 
> Duzongpeng; Michael Richardson  > > Cc: Anima WG  > > Subject: Re: 
> [Anima] Whether IPv6 only for ACP? //RE: I-D Action:
>  > > A network with autonomic functions (we all agree that a fully  > 
> > > *data plane* any protocol the operator wants to use, including 
> IPv4,  > > appletalk and IPv8 (when it comes).
>  > >
>  > > The statement is for the signalling, messaging and other 
> protocols  > > INSIDE the ACP, used by Autonomic Service Agents.
>  > >
>  > > Autonomic Service Agents will be exposed to a developer 
> community, and  > > the vendors implementing the ACP. There is 
> absolutely no reason to  > > standardise more than one protocol for 
> this purpose.
>  > >
>  > > MichaelR is right: You don't need to actively deploy IPv6 to use 
> the  > > ACP. It just happens. With one caveat: If you connect an NMS 
> system  > > into the ACP for "virtual out of band" usage, then that 
> system needs  > > to support IPv6. But that is typically not a 
> problem, in our experience.
>  > >
>  > > In other words: We're saying that *autonomic functions* (which 
> the end  > > user isn't exposed to at all) are exclusively IPv6, but 
> the network  > > can provide any service the operator wants. 
> Specifically, an autonomic  > > function (running on an IPv6 control 
> plane) may well negotiate  > > addressing for IPv4 services.
>  > >
>  > > Michael
>  > >
>  > > > From: Duzongpeng [mailto:[email-masked]]  > > > Sent: 25 
> June 2015 04:06  > > > To: Michael Richardson; Michael Behringer 
> (mbehring)  > > > Cc: Anima WG  > > > Subject: Whether IPv6 only for 
> ACP? //RE: [Anima] I-D Action:
> draft-
>  > > > Of course, an IPv6 only autonomic control plane is ok for all 
> the  > > > services in autonomic network, and the solution has the 
> advantage of  > > > simplicity as mentioned by Michael Behringer.
>  > > >
>  > > > In the beginning of the ACP deployment, the network operator 
> may  > > not  > > > be very confident about the decisions made by the 
> autonomic network.
>  > > > perhaps we need to provide IPv4-based ACP as an option for 
> these  > > > parts of operators. Otherwise, we can only answer them 
> "sorry, we  > > > only support  > > > IPv6 here".
>  > > >
>  > > > As IPv4 has been widely deployed, perhaps an IPv4-based  > > 
> autonomic  > > > network will be accepted by more network managers at 
> the beginning.
>  > > >
> > > > IPv6 one. Thus, perhaps some work needs to be done at this  > > 
>  > > > From: Anima [mailto:[email-masked]] On Behalf Of 
> Michael  > > > Richardson  > > > Sent: Thursday, June 25, 2015 1:12 AM  
> > > > To: Michael Behringer (mbehring)  > > > Cc: Anima WG  > > > 
> IPv6, for  > > > >> > simplicity reasons.
>  > > > >>
>  > > > >> extraordinary circumstances. The GDNP design is 
> fundamentally  > > > IP- version  > > > >> independent.
>  > > >
>  > > > > Yes, as long as it's really "extraordinary" ;-) That 2119 
> says  > > > > "SHOULD" means like you need a really good reason to not 
> do it.
>  > What
> implementation we  > > > > often get the requirement "we want IPv4", 
> and when you dig,  > > > the reason  > > > > is that they don't want 
> to deploy IPv6, and that's the only  > > > > reason. Slippery slope...
>  &gt
> 
> 
>

---

From: Duzongpeng <[email-masked]>
Date: Sat, 27 Jun 2015 02:31:09 +0000

Hi Michael Richardson,

Just ensure there is no misunderstanding here. IMO, the ACP is mostly software based. 
Of course, normally only new products can provide that feature.

Best regards
Zongpeng Du

-----Original Message-----
From: Anima [mailto:[email-masked]] On Behalf Of Michael Richardson
Sent: Saturday, June 27, 2015 2:47 AM
To: Anima WG
Subject: Re: [Anima] Whether IPv6 only for ACP? //RE: I-D Action: draft-behringer-anima-autonomic-addressing-01.txt

It's a new fangled protocol that has nothing to do with any of the deployed production network.  As such, it is *ENTIRELY* greenfield.
It's all new code.   It likely doesn't even get forwarded using whatever
ASICs your hardware might have...

If someone wants to do this with something that looks like IPv4, that's fine, but I want nobody complaining if we specify a mechanism (such as ULAs or ND or SEND) that does never been defined in the thing that looks like IPv4.